classdef ChannelModel
    
    properties
        ChannelMessages
        ChannelSum
        ChannelResiduals
        InstrumentGammas
    end
    
    methods
        function CM = ChannelModel(channelMessages, wholeMarket, channelSum, iInj)
           CM.ChannelMessages = channelMessages;
           CM.ChannelSum = channelSum;
           
           %Get residuals according to step 1
           local_model = LinearModel.fit(wholeMarket', channelSum');
           CM.ChannelResiduals = double(local_model.Residuals(:,1)); 

           %Perform all instrument regressions and store gamma
           for i = 1:size(channelMessages)
               xVar(:,1) = wholeMarket';
               xVar(:,2) = CM.ChannelResiduals;
               
               if iInj == 1
                   xVar(:,2) = CM.ChannelResiduals - channelMessages(i,:)'; 
               end
               
              stock_model = LinearModel.fit(xVar, channelMessages(i,:)');
              gamma = double(stock_model.Coefficients(3,1));
              CM.InstrumentGammas(i) = gamma;
           end
           
        end
    end
    
end

