%% Clear Workspace
clear;

%% Global Vars
n_periods = 21450;

%% Evenly Distributed Stocks

chan1_n = 396;
chan2_n = 396;
chan3_n = 396;
chan4_n = 396;
chan5_n = 396;
chan6_n = 396;

%% Create Channels, Sums, and Market

chan1 = CreateChannelMessages_roughExponential(chan1_n, n_periods);
chan2 = CreateChannelMessages_roughExponential(chan2_n, n_periods);
chan3 = CreateChannelMessages_roughExponential(chan3_n, n_periods);
chan4 = CreateChannelMessages_roughExponential(chan4_n, n_periods);
chan5 = CreateChannelMessages_roughExponential(chan5_n, n_periods);
chan6 = CreateChannelMessages_roughExponential(chan6_n, n_periods);

chan1_sum = sum(chan1,1);
chan2_sum = sum(chan2,1);
chan3_sum = sum(chan3,1);
chan4_sum = sum(chan4,1);
chan5_sum = sum(chan5,1);
chan6_sum = sum(chan6,1);

wholeMarket = chan1_sum + chan2_sum + chan3_sum + chan4_sum + chan5_sum + chan6_sum;

%% Make Collections (for looping)

channelSums{1} = chan1_sum;
channelSums{2} = chan2_sum;
channelSums{3} = chan3_sum;
channelSums{4} = chan4_sum;
channelSums{5} = chan5_sum;
channelSums{6} = chan6_sum;

channelMessages{1} = chan1;
channelMessages{2} = chan2;
channelMessages{3} = chan3;
channelMessages{4} = chan4;
channelMessages{5} = chan5;
channelMessages{6} = chan6;

%% Create Channel Models

channelModels = cell(6,6);

for i = 1:6
    for j = 1:6
           iInj = 0;
        if i == j
           iInj = 1; 
        end
        channelModel = ChannelModel(channelMessages{i},wholeMarket,channelSums{j}, iInj);
        channelModels{i,j} = channelModel;
    end
end

%% Get Average Gammas

averageGammas = zeros(6,6);

for i = 1:6
    for j = 1:6
        channelModel = channelModels{i,j};
        averageGammas(i,j) = mean(channelModel.InstrumentGammas);
    end
end



